/* keyboard-mapping-manager.c generated by valac 0.46.6, the Vala compiler
 * generated from keyboard-mapping-manager.vala, do not modify */

/* This file is part of GNOME Games. License: GPL-3.0+.*/

#include <glib-object.h>
#include <retro-gtk.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>

#define GAMES_TYPE_KEYBOARD_MAPPING_MANAGER (games_keyboard_mapping_manager_get_type ())
#define GAMES_KEYBOARD_MAPPING_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAMES_TYPE_KEYBOARD_MAPPING_MANAGER, GamesKeyboardMappingManager))
#define GAMES_KEYBOARD_MAPPING_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAMES_TYPE_KEYBOARD_MAPPING_MANAGER, GamesKeyboardMappingManagerClass))
#define GAMES_IS_KEYBOARD_MAPPING_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAMES_TYPE_KEYBOARD_MAPPING_MANAGER))
#define GAMES_IS_KEYBOARD_MAPPING_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAMES_TYPE_KEYBOARD_MAPPING_MANAGER))
#define GAMES_KEYBOARD_MAPPING_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAMES_TYPE_KEYBOARD_MAPPING_MANAGER, GamesKeyboardMappingManagerClass))

typedef struct _GamesKeyboardMappingManager GamesKeyboardMappingManager;
typedef struct _GamesKeyboardMappingManagerClass GamesKeyboardMappingManagerClass;
typedef struct _GamesKeyboardMappingManagerPrivate GamesKeyboardMappingManagerPrivate;
enum  {
	GAMES_KEYBOARD_MAPPING_MANAGER_0_PROPERTY,
	GAMES_KEYBOARD_MAPPING_MANAGER_MAPPING_PROPERTY,
	GAMES_KEYBOARD_MAPPING_MANAGER_NUM_PROPERTIES
};
static GParamSpec* games_keyboard_mapping_manager_properties[GAMES_KEYBOARD_MAPPING_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
#define _g_type_class_unref0(var) ((var == NULL) ? NULL : (var = (g_type_class_unref (var), NULL)))
enum  {
	GAMES_KEYBOARD_MAPPING_MANAGER_CHANGED_SIGNAL,
	GAMES_KEYBOARD_MAPPING_MANAGER_NUM_SIGNALS
};
static guint games_keyboard_mapping_manager_signals[GAMES_KEYBOARD_MAPPING_MANAGER_NUM_SIGNALS] = {0};

struct _GamesKeyboardMappingManager {
	GObject parent_instance;
	GamesKeyboardMappingManagerPrivate * priv;
};

struct _GamesKeyboardMappingManagerClass {
	GObjectClass parent_class;
};

struct _GamesKeyboardMappingManagerPrivate {
	RetroKeyJoypadMapping* _mapping;
	GFile* mapping_file;
	GFileMonitor* mapping_monitor;
};

static gint GamesKeyboardMappingManager_private_offset;
static gpointer games_keyboard_mapping_manager_parent_class = NULL;

GType games_keyboard_mapping_manager_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GamesKeyboardMappingManager, g_object_unref)
#define GAMES_KEYBOARD_MAPPING_MANAGER_MAPPING_FILE_NAME "keyboard-mapping.txt"
#define GAMES_KEYBOARD_MAPPING_MANAGER_GROUP_NAME "KeyboardMapping"
static void games_keyboard_mapping_manager_load_mapping (GamesKeyboardMappingManager* self);
static void games_keyboard_mapping_manager_set_mapping (GamesKeyboardMappingManager* self,
                                                 RetroKeyJoypadMapping* value);
RetroKeyJoypadMapping* games_keyboard_mapping_manager_get_mapping (GamesKeyboardMappingManager* self);
gboolean games_keyboard_mapping_manager_is_default (GamesKeyboardMappingManager* self);
void games_keyboard_mapping_manager_save_mapping (GamesKeyboardMappingManager* self,
                                                  RetroKeyJoypadMapping* mapping);
gchar* games_application_get_config_dir (void);
void games_application_try_make_dir (const gchar* path);
void games_keyboard_mapping_manager_delete_mapping (GamesKeyboardMappingManager* self);
GamesKeyboardMappingManager* games_keyboard_mapping_manager_new (void);
GamesKeyboardMappingManager* games_keyboard_mapping_manager_construct (GType object_type);
static GObject * games_keyboard_mapping_manager_constructor (GType type,
                                                      guint n_construct_properties,
                                                      GObjectConstructParam * construct_properties);
static void _games_keyboard_mapping_manager_load_mapping_g_file_monitor_changed (GFileMonitor* _sender,
                                                                          GFile* file,
                                                                          GFile* other_file,
                                                                          GFileMonitorEvent event_type,
                                                                          gpointer self);
static void games_keyboard_mapping_manager_finalize (GObject * obj);
static void _vala_games_keyboard_mapping_manager_get_property (GObject * object,
                                                        guint property_id,
                                                        GValue * value,
                                                        GParamSpec * pspec);
static void _vala_games_keyboard_mapping_manager_set_property (GObject * object,
                                                        guint property_id,
                                                        const GValue * value,
                                                        GParamSpec * pspec);

static inline gpointer
games_keyboard_mapping_manager_get_instance_private (GamesKeyboardMappingManager* self)
{
	return G_STRUCT_MEMBER_P (self, GamesKeyboardMappingManager_private_offset);
}

static void
games_keyboard_mapping_manager_load_mapping (GamesKeyboardMappingManager* self)
{
	GFile* _tmp0_;
	RetroKeyJoypadMapping* _tmp3_;
	RetroKeyJoypadMapping* _tmp4_;
	GKeyFile* mapping_key_file = NULL;
	GKeyFile* _tmp5_;
	GEnumClass* enumc = NULL;
	GTypeClass* _tmp12_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->mapping_file;
	if (!g_file_query_exists (_tmp0_, NULL)) {
		RetroKeyJoypadMapping* _tmp1_;
		RetroKeyJoypadMapping* _tmp2_;
		g_debug ("keyboard-mapping-manager.vala:30: User keyboard mapping file doesn't e" \
"xist.");
		_tmp1_ = retro_key_joypad_mapping_new_default ();
		_tmp2_ = _tmp1_;
		games_keyboard_mapping_manager_set_mapping (self, _tmp2_);
		_g_object_unref0 (_tmp2_);
		g_signal_emit (self, games_keyboard_mapping_manager_signals[GAMES_KEYBOARD_MAPPING_MANAGER_CHANGED_SIGNAL], 0);
		return;
	}
	_tmp3_ = retro_key_joypad_mapping_new ();
	_tmp4_ = _tmp3_;
	games_keyboard_mapping_manager_set_mapping (self, _tmp4_);
	_g_object_unref0 (_tmp4_);
	_tmp5_ = g_key_file_new ();
	mapping_key_file = _tmp5_;
	{
		GKeyFile* _tmp6_;
		GFile* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		_tmp6_ = mapping_key_file;
		_tmp7_ = self->priv->mapping_file;
		_tmp8_ = g_file_get_path (_tmp7_);
		_tmp9_ = _tmp8_;
		g_key_file_load_from_file (_tmp6_, _tmp9_, G_KEY_FILE_NONE, &_inner_error0_);
		_g_free0 (_tmp9_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch34_g_error;
		}
	}
	goto __finally34;
	__catch34_g_error:
	{
		GError* e = NULL;
		GError* _tmp10_;
		const gchar* _tmp11_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp10_ = e;
		_tmp11_ = _tmp10_->message;
		g_critical ("keyboard-mapping-manager.vala:43: %s", _tmp11_);
		g_signal_emit (self, games_keyboard_mapping_manager_signals[GAMES_KEYBOARD_MAPPING_MANAGER_CHANGED_SIGNAL], 0);
		_g_error_free0 (e);
		_g_key_file_unref0 (mapping_key_file);
		return;
	}
	__finally34:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_key_file_unref0 (mapping_key_file);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_tmp12_ = g_type_class_ref (retro_joypad_id_get_type ());
	enumc = (GEnumClass*) _tmp12_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp13_ = FALSE;
			_tmp13_ = TRUE;
			while (TRUE) {
				GEnumClass* _tmp14_;
				GEnumValue* _tmp15_;
				gint _tmp15__length1;
				GEnumValue _tmp16_;
				gchar* button = NULL;
				GEnumClass* _tmp17_;
				GEnumValue* _tmp18_;
				gint _tmp18__length1;
				GEnumValue _tmp19_;
				const gchar* _tmp20_;
				gchar* _tmp21_;
				if (!_tmp13_) {
					i = i + 1;
				}
				_tmp13_ = FALSE;
				_tmp14_ = enumc;
				_tmp15_ = _tmp14_->values;
				_tmp15__length1 = _tmp14_->n_values;
				_tmp16_ = _tmp15_[i];
				if (!(_tmp16_.value < ((gint) RETRO_JOYPAD_ID_COUNT))) {
					break;
				}
				_tmp17_ = enumc;
				_tmp18_ = _tmp17_->values;
				_tmp18__length1 = _tmp17_->n_values;
				_tmp19_ = _tmp18_[i];
				_tmp20_ = _tmp19_.value_nick;
				_tmp21_ = g_strdup (_tmp20_);
				button = _tmp21_;
				{
					gint key = 0;
					GKeyFile* _tmp22_;
					const gchar* _tmp23_;
					RetroKeyJoypadMapping* _tmp24_;
					GEnumClass* _tmp25_;
					GEnumValue* _tmp26_;
					gint _tmp26__length1;
					GEnumValue _tmp27_;
					_tmp22_ = mapping_key_file;
					_tmp23_ = button;
					key = g_key_file_get_integer (_tmp22_, GAMES_KEYBOARD_MAPPING_MANAGER_GROUP_NAME, _tmp23_, &_inner_error0_);
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						goto __catch35_g_error;
					}
					_tmp24_ = self->priv->_mapping;
					_tmp25_ = enumc;
					_tmp26_ = _tmp25_->values;
					_tmp26__length1 = _tmp25_->n_values;
					_tmp27_ = _tmp26_[i];
					retro_key_joypad_mapping_set_button_key (_tmp24_, (RetroJoypadId) _tmp27_.value, (guint16) key);
				}
				goto __finally35;
				__catch35_g_error:
				{
					GError* e = NULL;
					GError* _tmp28_;
					const gchar* _tmp29_;
					e = _inner_error0_;
					_inner_error0_ = NULL;
					_tmp28_ = e;
					_tmp29_ = _tmp28_->message;
					g_critical ("keyboard-mapping-manager.vala:57: %s", _tmp29_);
					_g_error_free0 (e);
				}
				__finally35:
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					_g_free0 (button);
					_g_type_class_unref0 (enumc);
					_g_key_file_unref0 (mapping_key_file);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
				_g_free0 (button);
			}
		}
	}
	g_signal_emit (self, games_keyboard_mapping_manager_signals[GAMES_KEYBOARD_MAPPING_MANAGER_CHANGED_SIGNAL], 0);
	_g_type_class_unref0 (enumc);
	_g_key_file_unref0 (mapping_key_file);
}

gboolean
games_keyboard_mapping_manager_is_default (GamesKeyboardMappingManager* self)
{
	GFile* _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->mapping_file;
	result = !g_file_query_exists (_tmp0_, NULL);
	return result;
}

void
games_keyboard_mapping_manager_save_mapping (GamesKeyboardMappingManager* self,
                                             RetroKeyJoypadMapping* mapping)
{
	gchar* config_dir = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	GKeyFile* mapping_key_file = NULL;
	GKeyFile* _tmp2_;
	GEnumClass* enumc = NULL;
	GTypeClass* _tmp3_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (mapping != NULL);
	_tmp0_ = games_application_get_config_dir ();
	config_dir = _tmp0_;
	_tmp1_ = config_dir;
	games_application_try_make_dir (_tmp1_);
	_tmp2_ = g_key_file_new ();
	mapping_key_file = _tmp2_;
	_tmp3_ = g_type_class_ref (retro_joypad_id_get_type ());
	enumc = (GEnumClass*) _tmp3_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp4_ = FALSE;
			_tmp4_ = TRUE;
			while (TRUE) {
				GEnumClass* _tmp5_;
				GEnumValue* _tmp6_;
				gint _tmp6__length1;
				GEnumValue _tmp7_;
				gchar* button = NULL;
				GEnumClass* _tmp8_;
				GEnumValue* _tmp9_;
				gint _tmp9__length1;
				GEnumValue _tmp10_;
				const gchar* _tmp11_;
				gchar* _tmp12_;
				guint16 key = 0U;
				GEnumClass* _tmp13_;
				GEnumValue* _tmp14_;
				gint _tmp14__length1;
				GEnumValue _tmp15_;
				GKeyFile* _tmp16_;
				const gchar* _tmp17_;
				if (!_tmp4_) {
					i = i + 1;
				}
				_tmp4_ = FALSE;
				_tmp5_ = enumc;
				_tmp6_ = _tmp5_->values;
				_tmp6__length1 = _tmp5_->n_values;
				_tmp7_ = _tmp6_[i];
				if (!(_tmp7_.value < ((gint) RETRO_JOYPAD_ID_COUNT))) {
					break;
				}
				_tmp8_ = enumc;
				_tmp9_ = _tmp8_->values;
				_tmp9__length1 = _tmp8_->n_values;
				_tmp10_ = _tmp9_[i];
				_tmp11_ = _tmp10_.value_nick;
				_tmp12_ = g_strdup (_tmp11_);
				button = _tmp12_;
				_tmp13_ = enumc;
				_tmp14_ = _tmp13_->values;
				_tmp14__length1 = _tmp13_->n_values;
				_tmp15_ = _tmp14_[i];
				key = retro_key_joypad_mapping_get_button_key (mapping, (RetroJoypadId) _tmp15_.value);
				_tmp16_ = mapping_key_file;
				_tmp17_ = button;
				g_key_file_set_integer (_tmp16_, GAMES_KEYBOARD_MAPPING_MANAGER_GROUP_NAME, _tmp17_, (gint) key);
				_g_free0 (button);
			}
		}
	}
	{
		GKeyFile* _tmp18_;
		GFile* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		_tmp18_ = mapping_key_file;
		_tmp19_ = self->priv->mapping_file;
		_tmp20_ = g_file_get_path (_tmp19_);
		_tmp21_ = _tmp20_;
		g_key_file_save_to_file (_tmp18_, _tmp21_, &_inner_error0_);
		_g_free0 (_tmp21_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch36_g_error;
		}
	}
	goto __finally36;
	__catch36_g_error:
	{
		GError* e = NULL;
		GError* _tmp22_;
		const gchar* _tmp23_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp22_ = e;
		_tmp23_ = _tmp22_->message;
		g_critical ("keyboard-mapping-manager.vala:84: %s", _tmp23_);
		_g_error_free0 (e);
	}
	__finally36:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_type_class_unref0 (enumc);
		_g_key_file_unref0 (mapping_key_file);
		_g_free0 (config_dir);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_g_type_class_unref0 (enumc);
	_g_key_file_unref0 (mapping_key_file);
	_g_free0 (config_dir);
}

void
games_keyboard_mapping_manager_delete_mapping (GamesKeyboardMappingManager* self)
{
	GFile* _tmp0_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->mapping_file;
	if (!g_file_query_exists (_tmp0_, NULL)) {
		return;
	}
	{
		GFile* _tmp1_;
		_tmp1_ = self->priv->mapping_file;
		g_file_delete (_tmp1_, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch37_g_error;
		}
	}
	goto __finally37;
	__catch37_g_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp2_ = e;
		_tmp3_ = _tmp2_->message;
		g_critical ("keyboard-mapping-manager.vala:96: %s", _tmp3_);
		_g_error_free0 (e);
	}
	__finally37:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

GamesKeyboardMappingManager*
games_keyboard_mapping_manager_construct (GType object_type)
{
	GamesKeyboardMappingManager * self = NULL;
	self = (GamesKeyboardMappingManager*) g_object_new (object_type, NULL);
	return self;
}

GamesKeyboardMappingManager*
games_keyboard_mapping_manager_new (void)
{
	return games_keyboard_mapping_manager_construct (GAMES_TYPE_KEYBOARD_MAPPING_MANAGER);
}

RetroKeyJoypadMapping*
games_keyboard_mapping_manager_get_mapping (GamesKeyboardMappingManager* self)
{
	RetroKeyJoypadMapping* result;
	RetroKeyJoypadMapping* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_mapping;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
games_keyboard_mapping_manager_set_mapping (GamesKeyboardMappingManager* self,
                                            RetroKeyJoypadMapping* value)
{
	g_return_if_fail (self != NULL);
	if (games_keyboard_mapping_manager_get_mapping (self) != value) {
		RetroKeyJoypadMapping* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_mapping);
		self->priv->_mapping = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, games_keyboard_mapping_manager_properties[GAMES_KEYBOARD_MAPPING_MANAGER_MAPPING_PROPERTY]);
	}
}

static void
_games_keyboard_mapping_manager_load_mapping_g_file_monitor_changed (GFileMonitor* _sender,
                                                                     GFile* file,
                                                                     GFile* other_file,
                                                                     GFileMonitorEvent event_type,
                                                                     gpointer self)
{
	games_keyboard_mapping_manager_load_mapping ((GamesKeyboardMappingManager*) self);
}

static GObject *
games_keyboard_mapping_manager_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GamesKeyboardMappingManager * self;
	gchar* config_dir = NULL;
	gchar* _tmp0_;
	gchar* path = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	GFile* _tmp4_;
	GError* _inner_error0_ = NULL;
	parent_class = G_OBJECT_CLASS (games_keyboard_mapping_manager_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAMES_TYPE_KEYBOARD_MAPPING_MANAGER, GamesKeyboardMappingManager);
	_tmp0_ = games_application_get_config_dir ();
	config_dir = _tmp0_;
	_tmp1_ = config_dir;
	_tmp2_ = g_build_filename (_tmp1_, GAMES_KEYBOARD_MAPPING_MANAGER_MAPPING_FILE_NAME, NULL);
	path = _tmp2_;
	_tmp3_ = path;
	_tmp4_ = g_file_new_for_path (_tmp3_);
	_g_object_unref0 (self->priv->mapping_file);
	self->priv->mapping_file = _tmp4_;
	{
		GFileMonitor* _tmp5_ = NULL;
		GFile* _tmp6_;
		GFileMonitor* _tmp7_;
		GFileMonitor* _tmp8_;
		GFileMonitor* _tmp9_;
		_tmp6_ = self->priv->mapping_file;
		_tmp7_ = g_file_monitor (_tmp6_, G_FILE_MONITOR_NONE, NULL, &_inner_error0_);
		_tmp5_ = _tmp7_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch38_g_error;
		}
		_tmp8_ = _tmp5_;
		_tmp5_ = NULL;
		_g_object_unref0 (self->priv->mapping_monitor);
		self->priv->mapping_monitor = _tmp8_;
		_tmp9_ = self->priv->mapping_monitor;
		g_signal_connect_object (_tmp9_, "changed", (GCallback) _games_keyboard_mapping_manager_load_mapping_g_file_monitor_changed, self, 0);
		_g_object_unref0 (_tmp5_);
	}
	goto __finally38;
	__catch38_g_error:
	{
		GError* e = NULL;
		GError* _tmp10_;
		const gchar* _tmp11_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp10_ = e;
		_tmp11_ = _tmp10_->message;
		g_critical ("keyboard-mapping-manager.vala:22: %s", _tmp11_);
		_g_error_free0 (e);
	}
	__finally38:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (path);
		_g_free0 (config_dir);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
	}
	games_keyboard_mapping_manager_load_mapping (self);
	_g_free0 (path);
	_g_free0 (config_dir);
	return obj;
}

static void
games_keyboard_mapping_manager_class_init (GamesKeyboardMappingManagerClass * klass,
                                           gpointer klass_data)
{
	games_keyboard_mapping_manager_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &GamesKeyboardMappingManager_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_games_keyboard_mapping_manager_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_games_keyboard_mapping_manager_set_property;
	G_OBJECT_CLASS (klass)->constructor = games_keyboard_mapping_manager_constructor;
	G_OBJECT_CLASS (klass)->finalize = games_keyboard_mapping_manager_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAMES_KEYBOARD_MAPPING_MANAGER_MAPPING_PROPERTY, games_keyboard_mapping_manager_properties[GAMES_KEYBOARD_MAPPING_MANAGER_MAPPING_PROPERTY] = g_param_spec_object ("mapping", "mapping", "mapping", retro_key_joypad_mapping_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	games_keyboard_mapping_manager_signals[GAMES_KEYBOARD_MAPPING_MANAGER_CHANGED_SIGNAL] = g_signal_new ("changed", GAMES_TYPE_KEYBOARD_MAPPING_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
games_keyboard_mapping_manager_instance_init (GamesKeyboardMappingManager * self,
                                              gpointer klass)
{
	self->priv = games_keyboard_mapping_manager_get_instance_private (self);
}

static void
games_keyboard_mapping_manager_finalize (GObject * obj)
{
	GamesKeyboardMappingManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAMES_TYPE_KEYBOARD_MAPPING_MANAGER, GamesKeyboardMappingManager);
	_g_object_unref0 (self->priv->_mapping);
	_g_object_unref0 (self->priv->mapping_file);
	_g_object_unref0 (self->priv->mapping_monitor);
	G_OBJECT_CLASS (games_keyboard_mapping_manager_parent_class)->finalize (obj);
}

GType
games_keyboard_mapping_manager_get_type (void)
{
	static volatile gsize games_keyboard_mapping_manager_type_id__volatile = 0;
	if (g_once_init_enter (&games_keyboard_mapping_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GamesKeyboardMappingManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) games_keyboard_mapping_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GamesKeyboardMappingManager), 0, (GInstanceInitFunc) games_keyboard_mapping_manager_instance_init, NULL };
		GType games_keyboard_mapping_manager_type_id;
		games_keyboard_mapping_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "GamesKeyboardMappingManager", &g_define_type_info, 0);
		GamesKeyboardMappingManager_private_offset = g_type_add_instance_private (games_keyboard_mapping_manager_type_id, sizeof (GamesKeyboardMappingManagerPrivate));
		g_once_init_leave (&games_keyboard_mapping_manager_type_id__volatile, games_keyboard_mapping_manager_type_id);
	}
	return games_keyboard_mapping_manager_type_id__volatile;
}

static void
_vala_games_keyboard_mapping_manager_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec)
{
	GamesKeyboardMappingManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GAMES_TYPE_KEYBOARD_MAPPING_MANAGER, GamesKeyboardMappingManager);
	switch (property_id) {
		case GAMES_KEYBOARD_MAPPING_MANAGER_MAPPING_PROPERTY:
		g_value_set_object (value, games_keyboard_mapping_manager_get_mapping (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_games_keyboard_mapping_manager_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec)
{
	GamesKeyboardMappingManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GAMES_TYPE_KEYBOARD_MAPPING_MANAGER, GamesKeyboardMappingManager);
	switch (property_id) {
		case GAMES_KEYBOARD_MAPPING_MANAGER_MAPPING_PROPERTY:
		games_keyboard_mapping_manager_set_mapping (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

